////////////////////////////////////////////////////////////////////////
// this file is used for test the class CSffReader
// by yongzhao
////////////////////////////////////////////////////////////////////////


#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <boost/foreach.hpp>
#include <boost/lexical_cast.hpp>
#include "read.h"
#include "sffReader.h"
#include "flowAligner.h"
#include "clusReader.h"
#include "flowComputer.h"
#include "faReader.h"
#include "aveLinkage.h"
using namespace std;
using namespace boost;

int main(int argc, char** argv)
{
	/*
	if (argc < 3)
	{
	cout << "usage: " << argv[0] << "*.sff" << endl;
	return -3;
	}
	*/
	/*
	*	// test the CFlowAligner
	CFlowAligner cc;
	cc.ReadData(argv[1]);
	cc.GlobalAlign();
	return 0;
	*/
	/*
	// test CAveLinkage
	list<vector<int> > l;
	for (int i = 0; i < 5; ++i)
	{
	vector<int> v;
	v.push_back(i);
	l.push_back(v);
	}
	vector<double> v;
	for (int i = 0; i < 10; ++i)
	{
	v.push_back((10-i)*10);
	}
	v.front() = 1;
	v.back() = 0;
	//v.push_back(0.0);
	//v.push_back(8.3);
	//v.push_back(2.2);
	CAveLinkage al;
	al.Cluster(l, v);
	return 0;
	*/
	string sName(argv[2]);

	// get all the reads
	CSffReader sffReader;
	sffReader.Read(argv[1]);

	// get all the cluster info
	CClusReader clusReader;
	clusReader.ReadClus((sName+".clust").c_str());
	//clusReader.ReadClus("Priest/DivergentGSFLXClean-AbundantOTU.clust");

	// aligner
	CFlowAligner c;

	unsigned int unFlowNum = sffReader.m_stFileHeader.unFlowNum;
	int nSize = clusReader.m_lvClus.size();

	// copy cluster seqs and compute distance of the cluster
	// create many data matrix, map each read into each cluster and put its flowgram into corresponding place
	// the first line is the master sequence in a cluster
	// the rest are sequences in this cluster
	int nSum = 0;
	vector<double*> vDataPt;
	int i = -1;
	BOOST_FOREACH(vector<string> v, clusReader.m_lvClus)
	{
		double* p = new double[(v.size()+1)*unFlowNum];
		vDataPt.push_back(p);
		nSum += v.size();
	}
	cout << "sum of computation:\t" << nSum << endl;

	// create one matrix
	// the first line is a single sequence
	// the rest are all of primary sequences
	double* aLast = new double[(nSize+1)*unFlowNum];
	i = -1;
	BOOST_FOREACH(vector<string> v, clusReader.m_lvPseudoCons)
	{
		++i;
		for (int j = 0; j < v.size(); ++j)
		{
			map<string, CRead*>::iterator it = sffReader.m_mReads.find(v[j]);
			if (it == sffReader.m_mReads.end())
			{
				cout << "cannot find a read in sff file" << endl;
				cout << v[j] << endl;
				continue;
			}
			copy(it->second->m_vdFlow.begin(), it->second->m_vdFlow.end(), vDataPt[i]+j*unFlowNum);
		}
		c.ReadData(v.size(), unFlowNum, vDataPt[i]);
		c.LocalAlign(1, 0);
		//for (int j = 0; j < c.m_vConsensus.size(); ++j)
		{
			//cout << vDataPt[i][j] << "\t" << c.m_vConsensus[j] << endl;
		}
		copy(c.m_vConsensus.begin(), c.m_vConsensus.end(), vDataPt[i]);
		// fill last matrix
		copy(c.m_vConsensus.begin(), c.m_vConsensus.end(), aLast+(i+1)*unFlowNum);
		//copy(it->second->m_vdFlow.begin(), it->second->m_vdFlow.end(), aLast+(i+1)*unFlowNum);
	}

	// compute DP value
	// haha
	//vector<string>& v = clusReader.m_lvClus.back();
	//c.ReadData((v.size()+1), unFlowNum, vDataPt[23]);
	//c.LocalAlign();
	//return 0;
	// haha
	vector<double> vStatics;
	list<vector<string> >::iterator itDiff = clusReader.m_lvDiff.begin();
	i = -1;
	BOOST_FOREACH(vector<string> v, clusReader.m_lvClus)
	{
		++i;
		cout << "The cluster # is " << i+1 << endl;
		for (int j = 0; j < v.size(); ++j)
		{
			map<string, CRead*>::iterator it = sffReader.m_mReads.find(v[j]);
			if (it == sffReader.m_mReads.end())
			{
				cout << "cannot find a read in sff file" << endl;
				cout << v[j] << endl;
				continue;
			}
			copy(it->second->m_vdFlow.begin(), it->second->m_vdFlow.end(), vDataPt[i]+(j+1)*unFlowNum);
		}
		c.ReadData((v.size()+1), unFlowNum, vDataPt[i]);
		// compute & store mean and sd
		c.LocalAlign(1, 1);
		vStatics.push_back(c.GetMean());
		vStatics.push_back(c.GetSd());

		for (int m = 0; m < v.size(); ++m)
		{
			cout << v[m] << "\t" << c.m_vValue[m] << "\t" << (*itDiff)[m] << endl;
		}
		++itDiff;

		cout << "Local\t\tmean:\t" << c.GetMean() << "\tsd:\t" << c.GetSd() << "\tmax:\t" << *max_element(c.m_vValue.begin(), c.m_vValue.end()) << endl;
		/*
		c.GlobalAlign();
		vStatics.push_back(c.GetMean());
		vStatics.push_back(c.GetSd());
		cout << "Global\t\tmean:\t" << c.GetMean() << "\tsd:\t" << c.GetSd() << endl;
		*/
	}


	// free 
	for (int i = 0; i < vDataPt.size(); ++i)
	{
		delete [] vDataPt[i];
	}

	// get the single sequence and compute the flowgram
	int nSinNum = 0;
	CFaReader single;
	single.Read((sName+".single").c_str());
	//single.Read("Priest/DivergentGSFLXClean-AbundantOTU.single");
	vector<string> vRare;
	for (int i = 0; i < single.m_vReads.size(); ++i)
	{
		map<string, CRead*>::iterator it = sffReader.m_mReads.find(single.m_vReads[i]->m_sName);
		if (it == sffReader.m_mReads.end())
		{
			cout << "cannot find a read in sff file" << endl;
			cout << single.m_vReads[i]->m_sName << endl;
			continue;
		}

		// copy data
		copy(it->second->m_vdFlow.begin(), it->second->m_vdFlow.end(), aLast);

		c.ReadData((nSize+1), unFlowNum, aLast);
		c.LocalAlign(1, 1);
		for (int m = 0; m < nSize; ++m)
		{
			cout << single.m_vReads[i]->m_sName << "\t" << c.m_vValue[m] << endl;
		}
		int nClu = c.GetMinIdx();
		int nCluIdx = (nClu-1)*2;
		if (c.GetMin() >= vStatics[nCluIdx]-3*vStatics[nCluIdx+1]
		&& c.GetMin() <= vStatics[nCluIdx]+3*vStatics[nCluIdx+1])
		{
			++nSinNum;
			cout << single.m_vReads[i]->m_sName << "(" << c.GetMin() << ")"
				<< " is a part of the cluster " << nClu
				<< "(" << vStatics[nCluIdx] << ", " << vStatics[nCluIdx+1] << ")" << endl;;
			//cout << "its value: " << c.GetMin() << endl;
			//cout << "Local\t\tthe mean: " << vStatics[nClu] << "\tthe sd: " << vStatics[nClu+1] << endl;
			//cout << "Global\t\tthe mean: " << vStatics[nClu+2] << "\tthe sd: " << vStatics[nClu+3] << endl;
		}
		else
		{
			vRare.push_back(single.m_vReads[i]->m_sName);
			cout << single.m_vReads[i]->m_sName << "(" << c.GetMin() << ")"
				<< " is closest to the cluster " << nClu
				<< "(" << vStatics[nCluIdx] << ", " << vStatics[nCluIdx+1] << ")" << endl;;
		}
	}
	cout << nSinNum << "/" << single.m_vReads.size() << " single sequences are recruited into clusters" << endl;

	delete [] aLast;

	// cluster rare sequences
	list<vector<int> > lRare;
	double* aRare = new double[vRare.size()*unFlowNum];
	for (int i = 0; i < vRare.size(); ++i)
	{
		map<string, CRead*>::iterator it = sffReader.m_mReads.find(vRare[i]);
		if (it == sffReader.m_mReads.end())
		{
			cout << "cannot find a read in sff file" << endl;
			cout << vRare[i] << endl;
			continue;
		}

		// copy data
		copy(it->second->m_vdFlow.begin(), it->second->m_vdFlow.end(), aRare+i*unFlowNum);
		// construct list for clustering
		vector<int> v;
		v.push_back(i);
		lRare.push_back(v);
	}

	cout << "# of rare sequences is " << vRare.size() << endl;
	c.ReadData(vRare.size(), unFlowNum, aRare);
	c.LocalAlign(vRare.size()-1, 1);
	/*
	int nn = vRare.size()-1;
	int mm = 0;
	for (int j = 0; j < c.m_vValue.size(); ++j)
	{
	cout << c.m_vValue[j] << "\t";
	++mm;
	if (mm == nn)
	{
	cout << endl;
	mm = 0;
	--nn;
	}
	}
	cout << "min: " << *min_element(c.m_vValue.begin(), c.m_vValue.end()) << endl;
	*/
	CAveLinkage al;
	al.Cluster(lRare, c.m_vValue);
	/*
	// count #
	int nClst = 0;
	int nNum = 0;
	BOOST_FOREACH(vector<int> v, lRare)
	{
	if (v.size() > 1)
	{
	++nClst;
	nNum += v.size();
	}
	}
	cout << "# of new cluster of rare sequences: " << nClst << endl;
	cout << "# of rare sequences which are clustered: " << nNum << endl;
	*/
	delete [] aRare;
	return 0;
}
